import QtQuick 2.5
import QtQuick.Window 2.2

Window {
    visible: true
    width: 800
    height: 650

    Rectangle {
        anchors.fill: parent
        color: "green"

        /////////////////////////////////////
        /////////////LISTVIEW////////////////
        /////////////////////////////////////
        Text {
            x: 100; y : 20
            font.pixelSize: 16
            text: "Clip for listview and its delegate"
        }
        Rectangle {
            x: 100; y : 50
            width: 200; height : 300
            color: "yellow"

            ListView {
                clip: true //HERE
                anchors.fill: parent
                model : ListModel {
                    ListElement {
                        name: "Bill Smith"
                        number: "555 3264"
                    }
                    ListElement {
                        name: "John Brown"
                        number: "555 8426"
                    }
                    ListElement {
                        name: "Sam Wise"
                        number: "555 0473"
                    }
                }
                delegate: Text {
                    clip: true // + HERE
                    font.pixelSize: 36
                    text: name + ": " + number
                }
            }

        }

        /////////////////////////////////////
        /////////////FLICKABLE///////////////
        /////////////////////////////////////
        Text {
            x: 500; y : 20
            font.pixelSize: 16
            text: "Clip for flickable and its child"
        }
        Rectangle {
            y : 50
            x : 450
            width : 300
            height: 300
            border.color : "black"
            border.width: 5
            color: "yellow"

            Flickable {
                y : 5
                x : 5
                width : 290
                height: 290
                contentHeight: 400
                clip: true //HERE

                Rectangle {
                    width: 290
                    height: 400
                    gradient : Gradient {
                        GradientStop {
                            color: "red"
                            position: 0
                        }
                        GradientStop {
                            color: "blue"
                            position: 1
                        }
                    }
                    clip: true // + HERE
                    Text {color: "white"; text : "shouldn't be visible over green background"}
                }
            }
        }


        /////////////////////////////////////
        /////////////TIMER///////////////////
        /////////////////////////////////////
        Text {
            x: 55; y : 380
            font.pixelSize: 16
            text: "Clip for parent and child rectangle with timer"
        }
        Rectangle {
            x : 90; y : 410
            width : 250; height : 150
            color:  "yellow"
            clip: true //HERE
            Component.onCompleted: clipTimer.start()
            Timer {
                id: clipTimer
                interval: 1000
                repeat : true
                onTriggered: clippedRect.rotation = (clippedRect.rotation==-90 ? 0 : -90)
            }
            Rectangle {
                id: clippedRect
                clip: true  // + HERE
                x : 20; y : 120
                width: 210; height: 60
                color: "purple"
                Text {color: "white"; text : "shouldn't be visible over green background"}
            }
        }

    }

}
